import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent.js';

const getClassNames = classNamesFunction();
class VerticalDividerBase extends StatelessComponent {
  render(h, ctx) {
    const {
      styles,
      theme,
      className
    } = ctx.props;
    const classNames = getClassNames(styles, {
      theme: theme,
      className
    });
    return h("span", {
      "class": classNames.wrapper
    }, [h("span", {
      "class": classNames.divider
    })]);
  }

}

export { VerticalDividerBase };
